unit ChSpec;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, ExtCtrls;

type
  TChangeSpec = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    LitersLab: TLabel;
    KmhLab: TLabel;
    MphLab: TLabel;
    CoLab: TLabel;
    GraphLab: TLabel;
    Liters: TEdit;
    kmh: TEdit;
    Mph: TEdit;
    Co: TEdit;
    Graphics: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    GroupBox2: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Label26: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    Label27: TLabel;
    CPUInis: TMaskEdit;
    SaveChanges: TButton;
    Cancel: TButton;
    Label28: TLabel;
    DefCurr: TComboBox;
    Label29: TLabel;
    DefDist: TComboBox;
    Help: TButton;
    DefaultDate: TRadioButton;
    Bevel1: TBevel;
    CustomDate: TRadioButton;
    Label30: TLabel;
    ShortDate: TEdit;
    Label31: TLabel;
    LongDate: TEdit;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SaveChangesClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure HelpClick(Sender: TObject);
    procedure DefaultDateClick(Sender: TObject);
    procedure CustomDateClick(Sender: TObject);
  private
    { Private declarations }
    f:TMemoryStream;
    janOffset:integer;
    procedure swapParts(start,a_size,b_size:cardinal);
  public
    { Public declarations }
  end;

var
  ChangeSpec: TChangeSpec;

implementation

{$R *.DFM}
uses FoProgi;
type st8=string[8];
     st4=string[4];
     st1=string[1];

const offsets:array[1..10,1..7] of cardinal=
{Contains the needed offsets in the following order:
 "liters","kmh-1","mph"," & Co.","Graphics:",First name letters for CPU players,
 two bytes containing default currency units and distance units
 The text "Graphics:" is a bit special because it's among normal texts, but can't be moved and
 its length can't be changed.}
      (( $3514f, $353d4, $35371, $621b7, $5341,$226fd, $1bb6), {American DOS}
       ( $35189, $3540e, $353ab, $621f1, $5381,$2273d, $1bb6), {English DOS}
       ( $3752f, $377b4, $37751, $6459b, $54f2,$23d4f, $1bb6), {French DOS}
       ( $35d0f, $35f94, $35f31, $62d77, $5396,$22ea5, $1bb6), {German DOS}
       ( $3770d, $37992, $3792f, $64775, $54ce,$23df7, $1bb6), {Spanish DOS}
       ($13c8f2,$13cb77,$13cb14,$187f24,$20bf2,$4df72,$c83eb), {American Windows}
       ($13caf2,$13cd77,$13cd14,$188124,$20c25,$4df98,$c842b), {English Windows}
       ($13f4f2,$13f777,$13f714,$18ab28,$21246,$50460,$cae3b), {French Windows}
       ($13d6f2,$13d977,$13d914,$188d24,$20e0a,$4ec9a,$c91db), {German Windows}
       ($13f6f2,$13f977,$13f914,$18ad24,$2142e,$5065e,$cb13b));{Spanish Windows}

{TTD uses separate procedures for showing money for every currency and for normal numbers.
 This means that you can change all currencies separately. Every procedure contains three thousand
 separators. These could be different in theory, but it has no use to show numbers like
 "$1.000,000 000", so the program changes all of them. For this, it has to know the offsets
 of all three thousand separators}

      currcode:array[1..10,1..6] of cardinal=
{To make currency symbols appear after numbers, the program has to swap two code parts
 of the given currency; by default, the first puts the currency symbol into the text, and the
 second puts the number. This list contains the offset of the first part for every currency
 and every executable. The order of the currencies are the following:
 Pounds, francs, dollars, yens, deutschmarks, pesetas}
      (( $3586c, $35989, $35ab7, $35bd9, $35d04, $35e2a), {American DOS}
       ( $358a6, $359c3, $35af1, $35c13, $35d3e, $35e64), {English DOS}
       ( $37c4c, $37d69, $37e97, $37fb9, $380e4, $3820a), {French DOS}
       ( $3642c, $36549, $36677, $36799, $368c4, $369ea), {German DOS}
       ( $37e2a, $37f47, $38075, $38197, $382c2, $383e8), {Spanish DOS}
       ($13d00f,$13d12c,$13d25a,$13d37c,$13d4a7,$13d5cd), {American Windows}
       ($13d20f,$13d32c,$13d45a,$13d57c,$13d6a7,$13d7cd), {English Windows}
       ($13fc0f,$13fd2c,$13fe5a,$13ff7c,$1400a7,$1401cd), {French Windows}
       ($13de0f,$13df2c,$13e05a,$13e17c,$13e2a7,$13e3cd), {German Windows}
       ($13fe0f,$13ff2c,$14005a,$14017c,$1402a7,$1403cd));{Spanish Windows}

      PartLen:array[1..6,1..2] of cardinal=
       ((4,270),(9,282),(4,275),(4,284),(9,274),(8,284));
{This array contains the lengths of the first and second parts of currency codes. For example,
 the first part for pounds is 4 bytes long, the second part is 270 bytes long}

      ThSeps:array[1..10,0..6] of cardinal=
{Offsets of the first thousand separators for every currency and every executable. The first
 entry (number 0) contains the offset of first thousand separator for normal numbers}
       (( $35773, $35890, $359ce, $35adb, $35c35, $35d2d, $35e8a), {American DOS}
        ( $357ad, $358ca, $35a08, $35b15, $35c6f, $35d67, $35ec4), {English DOS}
        ( $37b53, $37c70, $37dae, $37ebb, $38015, $3810d, $3826a), {French DOS}
        ( $36333, $36450, $3658e, $3669b, $367f5, $368ed, $36a4a), {German DOS}
        ( $37d31, $37e4e, $37f8c, $38099, $381f3, $382eb, $38448), {Spanish DOS}
        ($13cf16,$13d033,$13d171,$13d27e,$13d3d8,$13d4d0,$13d62d), {American Windows}
        ($13d116,$13d233,$13d371,$13d47e,$13d5d8,$13d6d0,$13d82d), {English Windows}
        ($13fb16,$13fc33,$13fd71,$13fe7e,$13ffd8,$1400d0,$14022d), {French Windows}
        ($13dd16,$13de33,$13df71,$13e07e,$13e1d8,$13e2d0,$13e42d), {German Windows}
        ($13fd16,$13fe33,$13ff71,$14007e,$1401d8,$1402d0,$14042d));{Spanish Windows}

      ThSepOffs:array[0..6,1..2] of cardinal=
       ((90,178),(90,178),(90,176),(90,178),(90,179),(90,178),(90,179));
{The offset of the second and third thousand separators for every currency.}

      GrafTextLen:array[1..10] of cardinal=
       (11,11,18,11,11,11,11,18,11,11);
{The length of the text meaning "Graphics:" for every version. Only the French version is different
 because its string is 18 characters long, others are 11 characters long}

      NewDateCode1:packed array[1..10] of byte=
       ($68,$56,$5D,$45,$00,$E9,$BB,$00,$00,$00);

      NewDateCode2:packed array[1..10] of byte=
       ($68,$51,$5D,$45,$00,$E9,$6B,$00,$00,$00);

      NewDateCode3:packed array[1..51] of byte=
       ($66,$50,$66,$D1,$E2,$0F,$B7,$D2,$66,$8B,$92,$46,$C0,$42,$00,$66,$52,$8B,$54,
        $24,$04,$8A,$02,$42,$0A,$C0,$74,$34,$3C,$01,$74,$38,$3C,$02,$74,$44,$3C,$03,
        $74,$6B,$3C,$04,$74,$4B,$88,$07,$47,$EB,$E4,$90,$90);

      NewDateCode4:packed array[1..92] of byte=
       ($83,$C4,$08,$E9,$6E,$F9,$FF,$FF,$0F,$B7,$44,$24,$02,$66,$05,$80,$07,$E8,$50,
        $00,$00,$00,$EB,$AD,$8B,$04,$24,$83,$E0,$1F,$8B,$1C,$85,$18,$BA,$42,$00,$EB,
        $0F,$8B,$04,$24,$C1,$E8,$03,$83,$E0,$3C,$8B,$98,$22,$C3,$42,$00,$8A,$03,$88,
        $07,$43,$47,$0A,$C0,$75,$F6,$4F,$EB,$82,$8B,$04,$24,$C1,$E8,$03,$83,$E0,$3C,
        $8B,$98,$B7,$69,$43,$00,$89,$1F,$83,$C7,$03,$E9,$69,$FF,$FF,$FF);

{New TTD date code that allows specifying a format string}

      OldDateCode1:packed array[1..10] of byte=
       ($E8,$31,$01,$00,$00,$E9,$BF,$FA,$FF,$FF);

      OldDateCode2:packed array[1..10] of byte=
       ($E8,$70,$00,$00,$00,$E9,$6F,$FA,$FF,$FF);

      OldDateCode3:packed array[1..51] of byte=
       ($50,$66,$D1,$E2,$66,$8B,$DA,$66,$8B,$9B,$46,$C0,$42,$00,$66,$C1,$EB,$03,$83,
        $E3,$3C,$8B,$9B,$22,$C3,$42,$00,$8A,$03,$88,$07,$43,$47,$0A,$C0,$75,$F6,$C6,
        $47,$FF,$20,$58,$66,$05,$80,$07,$E9,$83,$00,$00,$00);

      OldDateCode4:packed array[1..92] of byte=
       ($66,$81,$FA,$6E,$01,$72,$1A,$66,$81,$EA,$6E,$01,$40,$66,$81,$EA,$6D,$01,$73,
        $F8,$66,$81,$C2,$6D,$01,$66,$83,$FA,$3B,$7C,$02,$66,$42,$50,$66,$D1,$E2,$66,
        $8B,$DA,$66,$8B,$83,$46,$C0,$42,$00,$66,$8B,$D8,$83,$E0,$1F,$8B,$14,$85,$18,
        $BA,$42,$00,$8A,$02,$88,$07,$42,$47,$0A,$C0,$75,$F6,$4F,$C6,$07,$20,$66,$C1,
        $EB,$03,$83,$E3,$3C,$8B,$83,$0B,$90,$42,$00,$89,$47,$01,$C6,$47);

{Parts of original TTD code used for restoring original after using custom format.
 I haven't found a better way to link them to the program}

      VarDCodeParts:array [1..10,1..3] of integer=
       (($000F330C,$000F35E8,$000F2CDE), {American DOS}
        ($000F3356,$000F3632,$000F2D28), {English DOS}
        ($000F3EC0,$000F419C,$000F3892), {French DOS}
        ($000F365C,$000F3938,$000F302E), {German DOS}
        ($000F3D0A,$000F3FE6,$000F36DC), {Spanish DOS}
        ($0042C046,$0042C322,$0042BA18), {American Windows}
        ($0042C07A,$0042C356,$0042BA4C), {English Windows}
        ($0042D07E,$0042D35A,$0042CA50), {French Windows}
        ($0042C558,$0042C834,$0042BF2A), {German Windows}
        ($0042D0F6,$0042D3D2,$0042CAC8));{Spanish Windows}

{Memory references in the date code vary in different versions. One of these is
 the address of "jan", that is modified when saving strings, but others have to
 remain the same no matter what code is used. These are stored here, and written
 to the appropriate place when saving changes}

      DebugList:array[1..10] of record
                                 s,o:integer;
                                end=
       ((s:$2030d; o: $ec915), {American DOS}
        (s:$2033b; o: $ec91b), {English DOS}
        (s:$21705; o: $ec911), {French DOS}
        (s:$20a51; o: $ec915), {German DOS}
        (s:$2172f; o: $ec917), {Spanish DOS}
        (s:$31046; o:$407c00), {American Windows}
        (s:$31076; o:$407c00), {English Windows}
        (s:$326a6; o:$407c00), {French Windows}
        (s:$31756; o:$407c00), {German Windows}
        (s:$32846; o:$407c00));{Spanish Windows}

{Start and offset of debug string list for every version. The date format strings
 will be stored in this list because it seems not to be used anymore.}

var CheckBoxes:array[1..6] of TCheckBox;
    ThSepEdits:array[0..6] of TEdit;
    CurrSymbols:array[1..6] of TEdit;

procedure TChangeSpec.FormShow(Sender: TObject);
var s:string[19];
    w:word;
    c:cardinal;
    i:integer;

 function ReadLen8Text(IncLen:boolean):st8;
 {Reads a 8-char-length string trom a code like this:
  mov d,[edi],xxxx (The first 4 characters) ($c707xxxxxxxx)
  mov d,[edi+4],xxxx (The last 4 characters) ($c74704xxxxxxxx)
  add edi,l (the length of the text) ($83c7ll)
  The result is a ShortString because it's easier to use for this purpose.
  F.position should be set to the first character of the string
  IncLen should be true if the real length is 1 more than l.}
 begin
  f.ReadBuffer(Result[1],4);
  f.position:=f.position+3;
  f.ReadBuffer(Result[5],4);
  f.position:=f.position+2;
  f.ReadBuffer(Result[0],1);
  if IncLen then inc(Result[0]);
 end;

 function ReadLen4Text:st4;
 {Reads a 4-char-length string trom a code like this:
  mov d,[edi],xxxx (the four characters) ($c707xxxxxxxx)
  add edi,l (length of the text) ($83c7ll)
  The result is a ShortString because it's easier to use for this purpose.
  F.position should be set to the first character of the string.}
 begin
  f.ReadBuffer(Result[1],4);
  f.position:=f.position+2;
  f.ReadBuffer(Result[0],1);
 end;

 function ReadLen1Text:st1;
 {Reads a 1-char-length string trom a code like this:
  mov b,[edi],x (x is the character) ($c607xx)
  inc edi ($47) if the length is 1
  -- or --
  nop ($90) if the length is 0
  The result is a ShortString because it's easier to use for this purpose.
  F.position should be set to the first character of the string.}
 begin
  f.ReadBuffer(Result[1],1);
  f.ReadBuffer(Result[0],1);
  if Result[0]=#$90 then
   Result[0]:=#0
  else
   Result[0]:=#1;
 end;

 function ReadNullTerm:string;
 {Reads characters from f to the result string until it reaches zero}
 var c:char;
 begin
  Result:='';
  f.ReadBuffer(c,1);
  while c<>#0 do
   begin
    Result:=Result+c;
    f.ReadBuffer(c,1);
   end;
 end;

 function MakeDateString(const s:string):string;
 var i:integer;
 begin
  Result:='';
  for i:=1 to length(s) do
   case s[i] of
    #1: Result:=Result+'%y';
    #2: Result:=Result+'%d';
    #3: Result:=Result+'%m';
    #4: Result:=Result+'%M';
    #136..#152: Result:=Result+'\c'+ColorLetters[ord(s[i])];
    '\': Result:=Result+'\\';
    #123..#135: ;
    '%': Result:=Result+'%%';
    else Result:=Result+s[i];
   end;
 end;

begin
 f:=TMemoryStream.Create;
 f.LoadFromFile(OrigExePath);
 {We read original texts of the left group box}
 f.position:=offsets[OrigType,1];
 LitersLab.Caption:='"'+ReadLen8Text(false)+'"';
 f.position:=offsets[OrigType,2];
 KmhLab.Caption:='"'+ReadLen4Text+'"';
 f.position:=offsets[OrigType,3];
 MphLab.Caption:='"'+ReadLen4Text+'"';
 f.position:=offsets[OrigType,4];
 CoLab.Caption:='"'+ReadLen8Text(true)+'"';
 f.position:=offsets[OrigType,5];
 f.ReadBuffer(s[1],GrafTextLen[OrigType]);
 s[0]:=chr(GrafTextLen[OrigType]);
 GraphLab.Caption:='"'+s+'"';
 f.size:=0;
 f.LoadFromFile(TransExePath);
 {We read translated texts of the left group box}
 f.position:=offsets[TransType,1];
 Liters.Text:=ReadLen8Text(false);
 f.position:=offsets[TransType,2];
 Kmh.Text:=ReadLen4Text;
 f.position:=offsets[TransType,3];
 Mph.Text:=ReadLen4Text;
 f.position:=offsets[TransType,4];
 Co.Text:=ReadLen8Text(true);
 f.position:=offsets[TransType,5];
 f.ReadBuffer(s[1],GrafTextLen[TransType]);
 s[0]:=chr(GrafTextLen[TransType]);
 While s[Length(s)]=' ' do dec(s[0]);
 {We trim the trailing spaces - they'll be put back if needed when saving}
 Graphics.MaxLength:=GrafTextLen[TransType];
 Graphics.Text:=s;
 Label8.Caption:=IntToStr(GrafTextLen[TransType])+' chars';
 {We read the first name letters for CPU players}
 f.Position:=offsets[TransType,6];
 f.ReadBuffer(s[1],19);
 s[0]:=#19;
 CPUInis.Text:=s;
 {We load the default currency and distance units to a word variable, then set ComboBoxes
  according to the high and low byte}
 f.position:=offsets[TransType,7];
 f.ReadBuffer(w,2);
 DefCurr.ItemIndex:=Lo(w);
 DefDist.ItemIndex:=Hi(w);
{We load all currency data}
{First we check the order of code parts}
 for w:=1 to 6 do
  begin
   f.Position:=CurrCode[TransType,w];
   f.ReadBuffer(c,4);
   if c=$3030bb66 then {The second part always starts with this sequence, so if we find this in
                        the place of the first part then currency symbol is after the number}
    begin
     swapParts(CurrCode[TransType,w],PartLen[w,2],PartLen[w,1]);
     {We swap the parts back, because they need to be in the original order to load thousand separators
      and currency symbols}
     CheckBoxes[w].Checked:=true;
    end
   else
    CheckBoxes[w].Checked:=false;
  end;
{We load the first thousand separators for every currency - the other two should be the same}
 for w:=0 to 6 do
  begin
   f.Position:=ThSeps[TransType,w];
   f.ReadBuffer(s[1],1);
   ThSepEdits[w].Text:=s[1];
  end;
{Now we load currency symbols. We must add offsets to the CurrCode values to get the first
 character of the currency symbol}
 f.Position:=CurrCode[TransType,1]+2;
 Edit1.Text:=ReadLen1Text;
 f.Position:=CurrCode[TransType,2]+2;
 Edit2.Text:=ReadLen4Text;
 f.Position:=CurrCode[TransType,3]+2;
 Edit3.Text:=ReadLen1Text;
 f.Position:=CurrCode[TransType,4]+2;
 Edit4.Text:=ReadLen1Text;
 f.Position:=CurrCode[TransType,5]+2;
 Edit5.Text:=ReadLen4Text;
{Pesetas are stored in a different way}
 f.Position:=CurrCode[TransType,6]+3;
 f.ReadBuffer(s[1],2);
 f.position:=f.position+2;
 f.ReadBuffer(s[0],1);
 Edit6.Text:=s;
 f.Position:=ExeTypes[TransType].CheckDateOffset;
 f.ReadBuffer(w,2);
 if w=$5066 then
  begin
   CustomDate.Checked:=true;
   f.Position:=ExeTypes[TransType].CheckDateOffset-258;
   f.ReadBuffer(i,4);
   i:=i-DebugList[TransType].o;
   f.Position:=i;
   LongDate.Text:=MakeDateString(ReadNullTerm);
   f.Position:=ExeTypes[TransType].CheckDateOffset-178;
   f.ReadBuffer(i,4);
   i:=i-DebugList[TransType].o;
   f.Position:=i;
   ShortDate.Text:=MakeDateString(ReadNullTerm);
   f.Position:=ExeTypes[TransType].CheckDateOffset+158;
   f.ReadBuffer(janOffset,4);
  end
 else
  begin
   DefaultDate.Checked:=true;
   f.Position:=ExeTypes[TransType].CheckDateOffset+163;
   f.ReadBuffer(janOffset,4);
  end;
end;

procedure TChangeSpec.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 f.Free;
end;

procedure TChangeSpec.SaveChangesClick(Sender: TObject);
var s:string[19];
    date1,date2:string;
    w:word;
    i,j:integer;

 procedure WriteLen8Text(s:st8;decLen:boolean);
 {It's like LoadLen8Text but it saves the text}
 begin
  f.WriteBuffer(s[1],4);
  f.position:=f.position+3;
  f.WriteBuffer(s[5],4);
  f.position:=f.position+2;
  if decLen then dec(s[0]);
  f.WriteBuffer(s[0],1);
 end;

 procedure WriteLen4Text(s:st4);
 {It's like LoadLen4Text but it saves the text}
 begin
  f.WriteBuffer(s[1],4);
  f.position:=f.position+2;
  f.WriteBuffer(s[0],1);
 end;

 procedure WriteLen1Text(s:st1);
 {It's like LoadLen1Text but it saves the text}
 begin
  if s='' then
   s[1]:=#$90
  else
   begin
    s[0]:=s[1];
    s[1]:=#$47;
   end;
  f.WriteBuffer(s,2);
 end;

 function ProcessDateFormat(const s1:string; var s2:string):boolean;
 var i:integer;
     s:string;
 begin
  Result:=false;
  s2:='';
  i:=1;
  while i<=Length(s1) do
   if (s1[i]='%') and (i<Length(s1)) then
    case s1[i+1] of
     'y','Y': begin
               i:=i+2; s2:=s2+#1;
              end;
     'd','D': begin
               i:=i+2; s2:=s2+#2;
              end;
     'm': begin
           i:=i+2; s2:=s2+#3;
          end;
     'M': begin
           i:=i+2; s2:=s2+#4;
          end;
     '%': i:=i+2;
     else begin
           s2:='Date format specifiers can''t have %-sequences other than %y,%d,%m,%M and %%';
           exit;
          end;
    end
   else
    begin
     s2:=s2+s1[i];
     inc(i);
    end;
  s:=s2;
  Result:=FoForm.CompileCStyleString(s,s2);
 end;

begin
 {If custom date format is enabled, we check if format strings are correct}
 if CustomDate.Checked then
  begin
   if not ProcessDateFormat(LongDate.Text,date1) then
    begin
     Application.MessageBox(PChar('There is an error in the long date format string:'#10#13+date1),'Error in format string',
     MB_ICONERROR or MB_OK);
     Exit;
    end
   else if not ProcessDateFormat(ShortDate.Text,date2) then
    begin
     Application.MessageBox(PChar('There is an error in the short date format string:'#10#13+date2),'Error in format string',
     MB_ICONERROR or MB_OK);
     Exit;
    end;
  end;
 {We save special text on the left}
 f.Position:=offsets[TransType,1];
 WriteLen8Text(Liters.Text,false);
 f.Position:=offsets[TransType,2];
 WriteLen4Text(kmh.Text);
 f.Position:=offsets[TransType,3];
 WriteLen4Text(Mph.Text);
 f.Position:=offsets[TransType,4];
 WriteLen8Text(Co.Text,true);
 {We fill the remaining space of "Graphics:" with spaces. The length of s doesn't matter because
  the number of saved characters depends on GrafTextLen}
 FillChar(s[1],GrafTextLen[TransType],' ');
 s:=Graphics.Text;
 f.Position:=offsets[TransType,5];
 f.WriteBuffer(s[1],GrafTextLen[TransType]);
 {We save CPU initials}
 s:=CPUInis.Text;
 f.Position:=offsets[TransType,6];
 f.WriteBuffer(s[1],19);
 {We put default distance units and default currency together into a word and save it}
 w:=(DefDist.ItemIndex shl 8) or DefCurr.ItemIndex;
 f.Position:=offsets[TransType,7];
 f.WriteBuffer(w,2);
 {We save thousand separators - three times each}
 for w:=0 to 6 do
  begin
   s:=ThSepEdits[w].Text;
   if s='' then s:=' '; {We must save a thousand separator for every currency, so it tere isn't one,
                         we assign a space to it.}
   f.Position:=ThSeps[TransType,w];
   f.WriteBuffer(s[1],1);
   f.Position:=ThSeps[TransType,w]+ThSepOffs[w,1];
   f.WriteBuffer(s[1],1);
   f.Position:=ThSeps[TransType,w]+ThSepOffs[w,2];
   f.WriteBuffer(s[1],1);
  end;
{We save currency symbols}
 f.Position:=CurrCode[TransType,1]+2;
 WriteLen1Text(Edit1.Text);
 f.Position:=CurrCode[TransType,2]+2;
 WriteLen4Text(Edit2.Text);
 f.Position:=CurrCode[TransType,3]+2;
 WriteLen1Text(Edit3.Text);
 f.Position:=CurrCode[TransType,4]+2;
 WriteLen1Text(Edit4.Text);
 f.Position:=CurrCode[TransType,5]+2;
 WriteLen4Text(Edit5.Text);
{Pesetas are stored in a different way}
 s:=Edit6.Text;
 f.Position:=CurrCode[TransType,6]+3;
 f.WriteBuffer(s[1],2);
 f.position:=f.position+2;
 f.WriteBuffer(s[0],1);
{If the user wanted to put the currency symbol after the number, we swap the two code parts}
 for w:=1 to 6 do
  if CheckBoxes[w].Checked then
   swapParts(CurrCode[TransType,w],PartLen[w,1],PartLen[w,2]);
 f.Position:=ExeTypes[TransType].CheckDateOffset;
 f.ReadBuffer(w,2);
 if DefaultDate.Checked then
  begin
   if w=$5066 then
    begin
     f.position:=ExeTypes[TransType].CheckDateOffset-259;
     f.WriteBuffer(OldDateCode1[1],10);
     f.position:=ExeTypes[TransType].CheckDateOffset-179;
     f.WriteBuffer(OldDateCode2[1],10);
     f.position:=ExeTypes[TransType].CheckDateOffset;
     f.WriteBuffer(OldDateCode3[1],51);
     f.position:=ExeTypes[TransType].CheckDateOffset+80;
     f.WriteBuffer(OldDateCode4[1],92);
     f.position:=ExeTypes[TransType].CheckDateOffset+10;
     f.WriteBuffer(VarDCodeParts[TransType,1],4);
     f.position:=ExeTypes[TransType].CheckDateOffset+23;
     f.WriteBuffer(VarDCodeParts[TransType,2],4);
     f.position:=ExeTypes[TransType].CheckDateOffset+123;
     f.WriteBuffer(VarDCodeParts[TransType,1],4);
     f.position:=ExeTypes[TransType].CheckDateOffset+136;
     f.WriteBuffer(VarDCodeParts[TransType,3],4);
     f.position:=ExeTypes[TransType].CheckDateOffset+163;
     f.WriteBuffer(janOffset,4);
    end;
  end
 else
  begin
   if w=$6650 then
    begin
     f.position:=ExeTypes[TransType].CheckDateOffset-259;
     f.WriteBuffer(NewDateCode1[1],10);
     f.position:=ExeTypes[TransType].CheckDateOffset-179;
     f.WriteBuffer(NewDateCode2[1],10);
     f.position:=ExeTypes[TransType].CheckDateOffset;
     f.WriteBuffer(NewDateCode3[1],51);
     f.position:=ExeTypes[TransType].CheckDateOffset+80;
     f.WriteBuffer(NewDateCode4[1],92);
     f.position:=ExeTypes[TransType].CheckDateOffset+11;
     f.WriteBuffer(VarDCodeParts[TransType,1],4);
     f.position:=ExeTypes[TransType].CheckDateOffset+113;
     f.WriteBuffer(VarDCodeParts[TransType,3],4);
     f.position:=ExeTypes[TransType].CheckDateOffset+130;
     f.WriteBuffer(VarDCodeParts[TransType,2],4);
     f.position:=ExeTypes[TransType].CheckDateOffset+158;
     f.WriteBuffer(JanOffset,4);
    end;
   f.Position:=DebugList[TransType].s;
   i:=f.Position+DebugList[TransType].o;
   f.WriteBuffer(PChar(date1)^,length(date1)+1);
   j:=f.Position+DebugList[TransType].o;
   f.WriteBuffer(PChar(date2)^,length(date2)+1);
   f.position:=ExeTypes[TransType].CheckDateOffset-258;
   f.WriteBuffer(i,4);
   f.position:=ExeTypes[TransType].CheckDateOffset-178;
   f.WriteBuffer(j,4);
  end;
 f.SaveToFile(TransExePath); {And we save everything}
 ModalResult:=mrOK;
end;

procedure TChangeSpec.swapParts(start, a_size, b_size: cardinal);
{Swaps two parts of f. the offset of the first part is in start, a_size and b_size is the size of
 the first and second part}
var a,b:array of byte;
begin
 f.Position:=start;
 SetLength(a,a_size);
 SetLength(b,b_size);
 f.ReadBuffer(a[0],a_size);
 f.ReadBuffer(b[0],b_size);
 f.Position:=start;
 f.WriteBuffer(b[0],b_size);
 f.WriteBuffer(a[0],a_size);
end;

procedure TChangeSpec.FormCreate(Sender: TObject);
begin
{We assign checkboxes and edits to array items. This is not an elegant solution, but I didn't want
 to create these components at runtime.}
 checkboxes[1]:=CheckBox1;
 checkboxes[2]:=CheckBox2;
 checkboxes[3]:=CheckBox3;
 checkboxes[4]:=CheckBox4;
 checkboxes[5]:=CheckBox5;
 checkboxes[6]:=CheckBox6;
 thsepEdits[0]:=Edit7;
 thsepEdits[1]:=Edit8;
 thsepEdits[2]:=Edit9;
 thsepEdits[3]:=Edit10;
 thsepEdits[4]:=Edit11;
 thsepEdits[5]:=Edit12;
 thsepEdits[6]:=Edit13;
 CurrSymbols[1]:=Edit1;
 CurrSymbols[2]:=Edit2;
 CurrSymbols[3]:=Edit3;
 CurrSymbols[4]:=Edit4;
 CurrSymbols[5]:=Edit5;
 CurrSymbols[6]:=Edit6;
end;

procedure TChangeSpec.Edit1Change(Sender: TObject);
{This procedure runs every time something is changed in the group box on the right. It refreshes
 previews of the changed currency or normal numbers}
var i:integer;
    thsep:string;
begin
 i:=(Sender as TControl).Tag; {The Tag of the Sender indicates which currency should be refreshed}
 if i=0 then {The tag of 0 means normal numbers. In this case we have to refresh a label}
  if Edit7.Text='' then
   Label26.Caption:='123 456'
  else
   Label26.Caption:='123'+Edit7.Text+'456'
 else {The settings of a currency were changed. We need to change the caption of a CheckBox}
  begin
   thsep:=thsepEdits[i].Text;
   if thsep='' then thsep:=' ';
   if CheckBoxes[i].Checked then
    CheckBoxes[i].Caption:='123'+thsep+'456'+CurrSymbols[i].Text
   else
    CheckBoxes[i].Caption:=CurrSymbols[i].Text+'123'+thsep+'456';
  end;
end;

procedure TChangeSpec.HelpClick(Sender: TObject);
begin
 Application.HelpCommand(HELP_CONTEXT,2);
end;

procedure TChangeSpec.DefaultDateClick(Sender: TObject);
begin
 ShortDate.Enabled:=false;
 LongDate.Enabled:=false;
end;

procedure TChangeSpec.CustomDateClick(Sender: TObject);
begin
 ShortDate.Enabled:=true;
 LongDate.Enabled:=true;
end;

end.
