unit Conf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, IniFiles;

type
  TConfigForm = class(TForm)
    Label1: TLabel;
    OrigPath: TEdit;
    OrigBrowse: TButton;
    Label2: TLabel;
    TransPath: TEdit;
    TransBrowse: TButton;
    Label3: TLabel;
    PatchPath: TEdit;
    PatchBrowse: TButton;
    OK: TButton;
    Cancel: TButton;
    OpenDialog1: TOpenDialog;
    Help: TButton;
    procedure OrigBrowseClick(Sender: TObject);
    procedure TransBrowseClick(Sender: TObject);
    procedure PatchBrowseClick(Sender: TObject);
    procedure OrigPathChange(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure HelpClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ConfigForm: TConfigForm;

implementation

uses FoProgi;

{$R *.DFM}

procedure TConfigForm.OrigBrowseClick(Sender: TObject);
begin
with OpenDialog1 do
 begin
  Options:=[ofHideReadOnly,ofPathMustExist,ofFileMustExist,ofEnableSizing];
  if InitialDir='' then InitialDir:=ExtractFilePath(OrigPath.Text);
  if Execute then OrigPath.Text:=FileName;
 end;
end;

procedure TConfigForm.TransBrowseClick(Sender: TObject);
begin
with OpenDialog1 do
 begin
  Options:=[ofHideReadOnly,ofPathMustExist,ofCreatePrompt,ofNoReadOnlyReturn,ofEnableSizing];
  if InitialDir='' then InitialDir:=ExtractFilePath(TransPath.Text);
  if Execute then TransPath.Text:=FileName;
 end;
end;

procedure TConfigForm.PatchBrowseClick(Sender: TObject);
begin
with OpenDialog1 do
 begin
  Options:=[ofHideReadOnly,ofPathMustExist,ofFileMustExist,ofEnableSizing];
  if InitialDir='' then InitialDir:=ExtractFilePath(PatchPath.Text);
  if Execute then PatchPath.Text:=FileName;
 end;
end;

procedure TConfigForm.OrigPathChange(Sender: TObject);
{Called after changing the first two edit boxes. We disable the OK button if either field is empty}
begin
 OK.Enabled:= (OrigPath.Text<>'') and (TransPath.Text<>'');
end;

procedure TConfigForm.OKClick(Sender: TObject);
var i:TIniFile;
begin
 if FoForm.CheckConfig(OrigPath.Text,TransPath.Text,PatchPath.Text) then
{If CheckConfig is false, we've already shown an error message}
  begin
   ModalResult:=mrOK; {Everything is OK - we can close the dialg box}
   {We update the variables of the main unit}
   FoProgi.OrigExePath:=OrigPath.Text;
   FoProgi.TransExePath:=TransPath.Text;
   FoProgi.PatchPath:=PatchPath.Text;
   {Then update the ini file}
   i:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'ttdtrans2.ini');
   i.WriteString('Paths','OrigExePath',OrigExePath);
   i.WriteString('Paths','TransExePath',TransExePath);
   i.WriteString('Paths','PatchPath',FoProgi.PatchPath);
   i.Free;
  end;
end;

procedure TConfigForm.FormShow(Sender: TObject);
begin
 {We fill the edit boxes according to the main unit variables}
 OrigPath.Text:=FoProgi.OrigExePath;
 TransPath.Text:=FoProgi.TransExePath;
 PatchPath.Text:=FoProgi.PatchPath;
end;

procedure TConfigForm.HelpClick(Sender: TObject);
begin
 Application.HelpCommand(HELP_CONTEXT,5);
end;

end.
