unit Find;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TFindForm = class(TForm)
    Label1: TLabel;
    SearchText: TEdit;
    FindNext: TButton;
    CloseForm: TButton;
    SearchIn: TRadioGroup;
    Direction: TRadioGroup;
    Options: TGroupBox;
    CaseSens: TCheckBox;
    WholeWords: TCheckBox;
    procedure CloseFormClick(Sender: TObject);
    procedure FindNextClick(Sender: TObject);
    procedure SearchTextChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FindForm: TFindForm;

implementation
uses FoProgi;
{$R *.DFM}

procedure TFindForm.CloseFormClick(Sender: TObject);
begin
 Close;
end;

procedure TFindForm.FindNextClick(Sender: TObject);
var i,j:cardinal;
    quit:boolean;

function CanFind(what,where:string):boolean;
var i:integer;
const delimiters=' .,?!;:\%()&'#13;
{Decides whether "what" can be found in "where"}
begin
 Result:=false;
 if not CaseSens.Checked then
  Begin
   what:=AnsiUpperCase(what); where:=AnsiUpperCase(where);
  end;
 if not WholeWords.Checked then
  Result:=AnsiPos(what,where)>0
 else
  for i:=1 to Length(where) do
   if ((i-1<1) or IsDelimiter(Delimiters,where,i-1)) and (Copy(where,i,Length(what))=what) and
      ((i+Length(what)>Length(where)) or IsDelimiter(Delimiters,where,i+Length(what))) then
    begin
     Result:=true;
     Exit;
    end;
end;

begin
{We search in the string grid cells depending on the search direction. If we find it, we set
 the current cell to it.}
 quit:=false;
 with FoForm.StringGrid1 do
  begin
   i:=Col; j:=row;
   while not quit do
    begin
     if Direction.ItemIndex=0 then
      if i=1 then i:=2
      else begin i:=1; inc(j) end
     else
      if i=2 then i:=1
      else begin i:=2; dec(j) end;
     if (j<1) or (j>2449) then
      begin
       Application.MessageBox(PChar(SearchText.Text),'Text not found',MB_ICONINFORMATION);
       quit:=true;
      end
     else
      if ((i=1) and (SearchIn.ItemIndex in [0,2]) or (i=2) and (SearchIn.ItemIndex in [1,2])) and
       CanFind(SearchText.Text,Cells[i,j]) then
       begin
        Col:=i; Row:=j; quit:=true;
       end;
    end;
  end;
end;
procedure TFindForm.SearchTextChange(Sender: TObject);
begin
 FindNext.Enabled:= SearchText.Text<>'';
end;

end.
