unit jumpto;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TJumpToForm = class(TForm)
    Label1: TLabel;
    JumpToNum: TEdit;
    Button1: TButton;
    Button2: TButton;
    procedure JumpToNumKeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  JumpToForm: TJumpToForm;

implementation

{$R *.DFM}

procedure TJumpToForm.JumpToNumKeyPress(Sender: TObject; var Key: Char);
begin
 {We convert Enter to pressing the OK button}
 if Key=#13 then
  begin
   Button1.Click;
   Key:=#0;
  end
 {We don't allow anything except digits and backspace}
 else if not (Key in ['0'..'9',#8]) then
  begin
   Beep; Key:=#0;
  end;
end;

procedure TJumpToForm.Button1Click(Sender: TObject);
var i:integer;
begin
 if JumpToNum.Text='' then {No text means no jump}
  modalResult:=mrCancel
 else
  begin
   i:=StrToInt(JumpToNum.Text); {We convert the text to number}
   if not ((i>=1) and (i<=2449)) then
    Application.MessageBox('You have to enter a number between 1 and 2449!','Error',MB_ICONERROR or MB_OK)
   else
    ModalResult:=mrOK; {The box can close if it's between 1 and 2449}
  end;
end;

procedure TJumpToForm.FormShow(Sender: TObject);
{When showing, we set focus to the edit box and select all its text}
begin
 JumpToNum.SetFocus;
 JumpToNum.SelectAll;
end;

procedure TJumpToForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
{We convert Escape to pressing Cancel}
 if Key=#27 then
  begin
   ModalResult:=mrCancel;
   Key:=#0;
  end;
end;

end.
