unit previewf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Menus;

type
  TPreviewForm = class(TForm)
    RichEdit1: TRichEdit;
    PopupMenu1: TPopupMenu;
    Changedefaulttextcolor1: TMenuItem;
    Changebackgroundcolor1: TMenuItem;
    ColorDialog1: TColorDialog;
    Double: TMenuItem;
    UseTTDFont: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Changedefaulttextcolor1Click(Sender: TObject);
    procedure Changebackgroundcolor1Click(Sender: TObject);
    procedure DoubleClick(Sender: TObject);
    procedure UseTTDFontClick(Sender: TObject);
  private
    FPreviewText:string;
    procedure SetPreviewText(const Value: string);
    procedure RefreshText(const s:string);
    { Private declarations }
  public
    property PreviewText:string write SetPreviewText;
    { Public declarations }
  end;

var
  PreviewForm: TPreviewForm;

implementation
uses FoProgi;
{$R *.DFM}

{ TPreviewForm }

procedure TPreviewForm.SetPreviewText(const Value: string);
var s:string;
begin
 if FoForm.CStyle.Checked then
  begin
   if not FoForm.CompileCStyleString(Value,s) then
    Exit;
  end
 else
  s:=Value;
 if s<>FPreviewText then
  begin
   FPreviewText:=s;
   RefreshText(s);
  end;
end;

procedure TPreviewForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 FoForm.Preview.Execute;
end;

procedure TPreviewForm.RefreshText(const s: string);
var s2:String;
    i:integer;
begin
 With RichEdit1 do
  begin
   Lines.Clear;
   With SelAttributes do
    begin
     Color:=Font.Color;
     Size:=8;
    end;
   for i:=1 to Length(s) do
   begin
    SelAttributes.Name:=Font.Name;
    SelAttributes.Charset:=Font.Charset;
    SelAttributes.Style:=Font.Style;
    s2:='';
    case s[i] of
     #13: s2:=#13#10;
     #14: if Double.Checked then
           SelAttributes.Size:=10
          else SelAttributes.Size:=5;
     #15: SelAttributes.Size:=14;
     #123: s2:=s2+'123,456';
     #124: s2:=s2+'12,345';
     #125: s2:=s2+'123';
     #126: s2:=s2+'1995';
     #127: s2:=s2+'$123,456';
     #128: s2:=s2+'*text*';
     #130: s2:=s2+'20th Jun 1995';
     #131: s2:=s2+'June 1995';
     #132: s2:=s2+'123kmh'#185;
     #135: s2:=s2+'12,300 liters';
     #136..#152: SelAttributes.Color:=Colors[Ord(s[i])-135];
    else
      s2:=s[i];
    end;
    if s2<>'' then
     SendMessage(Handle,EM_REPLACESEL,0,Integer(PChar(s2)));
   end;
  SendMessage(Handle,EM_LINESCROLL,0,-SendMessage(Handle,EM_GETFIRSTVISIBLELINE,0,0));
  end;
end;

procedure TPreviewForm.Changedefaulttextcolor1Click(Sender: TObject);
begin
 ColorDialog1.Color:=RichEdit1.Font.Color;
 if ColorDialog1.Execute then
  begin
   RichEdit1.Font.Color:=ColorDialog1.Color;
   RefreshText(FPreviewText);
  end;
end;

procedure TPreviewForm.Changebackgroundcolor1Click(Sender: TObject);
begin
 ColorDialog1.Color:=RichEdit1.Color;
 if ColorDialog1.Execute then
  RichEdit1.Color:=ColorDialog1.Color;
end;

procedure TPreviewForm.DoubleClick(Sender: TObject);
begin
 Double.Checked:=not Double.Checked;
 RefreshText(FPreviewText);
end;

procedure TPreviewForm.UseTTDFontClick(Sender: TObject);
begin
 UseTTDFont.Checked:=not UseTTDFont.Checked;
 if UseTTDFont.Checked then
  with RichEdit1.Font do
   begin
    Name:='Transport Tycoon';
    Charset:=ANSI_CHARSET;
    Style:=[];
   end
 else
  RichEdit1.ParentFont:=true;
 RichEdit1.SelAttributes.Assign(RichEdit1.Font);
 RefreshText(FPreviewText);
end;

end.
