unit runmkpttxt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TRunCompiler = class(TForm)
    GiveUp: TButton;
    Label1: TLabel;
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure RunMkPtTxt(var Msg:TMessage); message WM_USER;
  public
    { Public declarations }
    CouldRunExe:boolean;
    ErrorCode:cardinal;
    ProgOutput:string;
  end;

var
  RunCompiler: TRunCompiler;

implementation

uses FoProgi;

{$R *.DFM}

procedure TRunCompiler.FormShow(Sender: TObject);
begin
 PostMessage(Handle,WM_USER,0,0);
end;

procedure TRunCompiler.RunMkPtTxt(var Msg: TMessage);
var startup:STARTUPINFO;
    process:PROCESS_INFORMATION;
    read_pipe,write_pipe:cardinal;
    security:SECURITY_ATTRIBUTES;
    s:string;
    length:integer;
begin
 Application.ProcessMessages;
 CouldRunExe:=false;
 ErrorCode:=0;
 {We create a pipe. The output or mkpttxt will be redirected to this pipe, so
  we can display it if necessary}
 with Security do
  begin
   nLength:=sizeof(security);
   lpSecurityDescriptor:=nil;
   bInheritHandle:=true;
  end;
 CreatePipe(read_pipe,write_pipe,@security,0);
 {Now we run mkpttxt as a child process, with output redirected to our pipe
  and without showing its window}
 FillChar(startup,sizeof(startup),0);
 with startup do
  begin
   cb:=sizeof(startup);
   dwFlags:=STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
   wShowWindow:=SW_HIDE;
   hStdOutput:=write_pipe;
   hStdError:=write_pipe;
  end;
 if not CreateProcess(PChar(ExtractFilePath(PatchPath)+'mkpttxt.exe'),'',nil,nil,true,0,nil,
                      PChar(ExtractFilePath(PatchPath)),startup,process) then
  begin
   ErrorCode:=GetLastError;
   FileClose(write_pipe);
   FileClose(read_pipe);
   ModalResult:=mrCancel;
   Exit;
  end;
 FileClose(write_pipe); {This handle is given to mkpttxt; we should release ours}
 repeat
  case MsgWaitForMultipleObjects(1,process.hProcess,false,INFINITE,QS_ALLINPUT) of
   WAIT_OBJECT_0: CouldRunExe:=true; {The program has terminated}
   WAIT_OBJECT_0+1: Application.ProcessMessages; {There is a message in the quene}
   else begin
         ErrorCode:=GetLastError;
         CloseHandle(process.hProcess);
         CloseHandle(process.hThread);
         FileClose(read_pipe);
         ModalResult:=mrCancel;
         Exit;
        end;
  end;
 until CouldRunExe or (ModalResult<>mrNone);
 {Now we can read the program output out of the pipe}
 progOutput:='';
 repeat
  SetLength(s,200);
  length:=FileRead(read_pipe,PChar(s)^,200);
  if length<0 then {If there is no more data or an error occured, the result is -1}
   s:=''
  else
   SetLength(s,length); {Else adjust size}
  ProgOutput:=ProgOutput+s;
 until length<0;
 FileClose(read_pipe);
 GetExitCodeProcess(process.hProcess,ErrorCode);
 CloseHandle(process.hProcess);
 CloseHandle(process.hThread);
 ModalResult:=mrOK;
end;

end.
